#include "ppdfviewer.h"

#include <qapplication.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qvbox.h>
#include <qpushbutton.h>
#include <qprinter.h>

//#include <iostream.h>

int main( int argc, char **argv )
{
	QApplication app( argc, argv );

//	int i;
//	for(i=0;i<app.argc();i++) fprintf( stderr, "Debug: %s\n",  argv[i]);//cout << argv[i];//qDebug(app.argv()[i]);

	if(argc==2) {

		//qDebug("argv 1: "+QString(argv[1]));

		QString fName = QString(argv[1]);
		QFile f; f.setName(fName);
		QFileInfo fi; fi.setFile(f);
		if(!f.exists()) {
			qDebug("Die Datei existiert nicht in diesem Pfad.");
			return 0;
		}
		if(f.open(IO_ReadOnly)) {
			f.close();
		} else {
			qDebug("Die Datei konnte nicht geffnet werden.");
			return 0;
		}

		PPdfViewer* viewer = new PPdfViewer(0);

		//viewer->pdfView()->enableAdobeReader();

		app.setMainWidget(viewer);

		viewer->resize(580,842);
		viewer->setColor(); // farbige Anzeige

		viewer->pdfView()->setData(fi.absFilePath());

		viewer->setCaption(" " + fi.fileName() + "  - PDF Viewer");

		QRect scr = QApplication::desktop()->screenGeometry();
		viewer->move(scr.center() - viewer->rect().center());

		viewer->show();

		viewer->pdfView()->loadData();

		return app.exec();
	}

	if(argc==3) {

		QString s = QString(argv[1]);
		if((s.lower().contains("print") && s.left(1)=="/") || s.left(2)=="/P"  || s.left(2)=="/p") {

			QString fName = QString(argv[2]);

			QFile f; f.setName(fName);
			QFileInfo fi; fi.setFile(f);

			if(f.open(IO_ReadOnly)) {

				char* data;
				uint dataLen=0;

				QDataStream dStr(&f);
				data = new char[fi.size()];
				dStr.readRawBytes(data,fi.size());
				f.close();
				dataLen = fi.size();

				PPdfView* ppdf = new PPdfView(0);

				QPrinter* printer = new QPrinter(QPrinter::HighResolution);
				printer->setFullPage(TRUE);
				printer->setPageSize(QPrinter::A4);
				//printer->setOrientation(QPrinter::Landscape);
				printer->setOrientation(QPrinter::Portrait);

				// Druckerdialog im Bildschirm zentrieren (deswegen braucht er ein parentWidget w)
				QWidget* w = new QWidget(0,"", Qt::WStyle_Customize | Qt::WStyle_NoBorder);
				w->setFixedWidth(400);
				w->setFixedHeight(400);
				QRect scr = QApplication::desktop()->screenGeometry();
				w->move(scr.center() - w->rect().center());
	
				if(printer->setup(w)) {

					if(dataLen>0) {
						//printData(char* data, uint len, QPrinter* printer, int page, QProgressDialog* progress, bool isColor, QString ownerPassword, QString userPassword)

						QString err = ppdf->printData(data, dataLen, printer, -1, 0, false, "", ""); // wenn isColor==true, dann noch Absturz: Bug!!!!

						if(err!="") {
							qDebug(err);
							return app.exec();
						} else {
							return 1;
						}
					}
				}
			} else {
				qDebug("Datei konnte nicht geffnet werden.");
			}

			qDebug("Druck nicht mglich");
			return 0;
		}
	}

	if(argc==1) {  //

		//QString tx = app.applicationDirPath();
		//qDebug("App path: "+tx);

		PPdfViewer* viewer = new PPdfViewer(0);

		//viewer->pdfView()->enableAdobeReader();
		//viewer->reduceButtons();
		//viewer->showToolBarTop(false);
		//viewer->showToolBarBottom(false);

		app.setMainWidget(viewer);

		QString fName = "test.pdf";

		QFile f; f.setName(fName);
		QFileInfo fi; fi.setFile(f);

		viewer->resize(580,842);
		
		//viewer->setColor();

		viewer->pdfView()->setData(fi.absFilePath());

		viewer->setCaption(" " + fi.fileName() + "  - PDF Viewer");

		QRect scr = QApplication::desktop()->screenGeometry();
		viewer->move(scr.center() - viewer->rect().center());

		viewer->show();

		viewer->pdfView()->loadData();

		return app.exec();
	}

	return 0;
}
