#ifndef PXML_FORMATPARSER_H
#define PXML_FORMATPARSER_H

#include <qxml.h>

class PXML_FormatParser : public QXmlDefaultHandler
{
public:
	PXML_FormatParser();

	void reset();
	QString getDataInstruction();
	QString getDataStartPrefix();
	QString getFormattedString();

	// virtuelle Funktionen von QXmlDefaultHandler berschreiben

	bool startElement(const QString&, const QString&, const QString& , const QXmlAttributes&);
	bool endElement(const QString&, const QString&, const QString&);
	bool characters(const QString&);
	
	void setDocumentLocator(QXmlLocator*);
	bool startDocument();
	bool endDocument();
	bool startPrefixMapping(const QString&, const QString&);
	bool endPrefixMapping(const QString&);
	bool ignorableWhitespace(const QString&);
	bool processingInstruction(const QString&, const QString&);
	bool skippedEntity(const QString&);
	QString errorString();

protected:
	QString data;
	QString dataInstruction;
	QString dataStartPrefix;
	int countTabs;
	int countAttributes;
};

#endif
