#ifndef PXMLVALIDATOR_H
#define PXMLVALIDATOR_H

#include <qvbox.h>

#include <qsciscintilla.h>

class QLabel;
class QTextEdit;
class QPushButton;

class QsciPrinter;

class PScintilla : public QsciScintilla
{
	Q_OBJECT

public:
	PScintilla(QWidget* parent=0, const char* name=0);

signals:
	void droppedFileName(QString);

protected:
	void dropEvent(QDropEvent*);
	void dragEnterEvent(QDragEnterEvent*);
};

class PXmlValidator : public QVBox
{
	Q_OBJECT

public:
	PXmlValidator(QWidget* parent=0, const char* name=0);

	~PXmlValidator();

	QTextEdit* editERR;
	PScintilla* editXML;

	void setXML(QString);
	void setErrorText(QString);
	void setCurrentPath(QString);
	void setMark(int);
	void setDoc(QString);

	QString getError();
	QString getXSDfromXML();

	static QString validate(QString fileXML);
	static QString format(QString fileXML);

public slots:
	QString validate();
	void revalidate();

	void format();

	void changeWrap();

	bool openValidate(QString);
	void open();
	void save();
	void saveAs();
	void print();

	bool isMark(int);
	void setMark();
	void gotoMarkForward();
	void gotoMarkBack();
	void gotoMarkCont();
	void deleteAllMarks();

	void showLine(int,int);
	void showDoc();

	void updataReUndo();

	void setStatus(int, int);

	void undo();
	void redo();

private:
	QsciPrinter* printer;

	bool bFormatted;

	QLabel* lblStatus;

	QPushButton* pbDoc;
	QPushButton* pbUndo;
	QPushButton* pbRedo;
	QPushButton* pbFormat;
	QPushButton* pbRevalid;
	QPushButton* pbPrint;
	QPushButton* pbSave;
	QPushButton* pbSaveAs;
	QPushButton* pbLoad;
	QPushButton* pbWrap;

	QString docFilePathName;

	QString currentPath;

	QString fileNameXML;
	QString fileNameXSD;

	QString errorInvalid;

	QValueList<int> markList;
};

#endif